'appHelp 1.03                                   
'                                                                            
'This include file displays an application help file created by GenHelp.exe
'just include it with your application program (#INCLUDE "appHelp.inc")
'displays the help as a treeview of headings, topics, and notes plus content 
'
'GenHelp is used to prepare the application help file e.g. "myApp.ahp"
'include "appHelp.inc" and call "myApp.ahp" from your program: appHelp "myApp.ahp", title$
'title$ is optional, and if not specified, defaults to "Application Help"
'
'-------------------------------------------------------------------------------------------

#INCLUDE once "TPrint.inc"

%IDC_appHelp_Treeview       = 101
%IDC_appHelp_Title          = 102
%IDC_appHelp_Textbox        = 103
%IDC_appHelp_Splitbar       = 104
%IDC_appHelp_StatusBar      = 105       
%IDM_appHelp_Find           = 121
%IDM_appHelp_Next           = 122
%IDM_appHelp_Prev           = 123
%IDM_appHelp_Print          = 124          
%IDM_appHelp_ExpandTopic    = 125
%IDM_appHelp_CollapseTopic  = 126             
%IDM_appHelp_ExpandAll      = 127
%IDM_appHelp_CollapseAll    = 128
%IDM_appHelp_F1             = 130

type editOption
   tabSpaces as long                                                        
   nWordWrap as long                                                    
end type

global appHelp_File            as string     'help file that is displayed
global appHelp_hDlg            as long       'help dialog handle
global appHelp_NumTree         as long       'number of tree items                                 
GLOBAL appHelp_Titles()        as string     'titles of tree items
global appHelp_Content()       AS STRING     'text for tree items
global appHelp_treeLevel()     as long       'level = 0 for topic and 1 for note
global appHelp_treeHandles()   as long       'tree item handles in treeview order 
global appHelp_Indexes()       as long       'indexes (sequenced only if not out of sort)
global appHelp_editOpt()       as editOption 'tabspaces and wordwrap 
global appHelp_hItem           as long       'saved handle to last selected item               
global appHelp_nFind           as long       'item number for find 
global origAppHelpTextboxProc  as long       'old proc handle for subclassing 
global hAppHelpTextbox         as long       'handle for textbox control
global hAppHelpMenu0           as long       'floating menu on treeview side
global hAppHelpMenu1           as long       'floating menu on textbox side
                           
sub appHelp(helpFile$, opt byval title$, byval h&, byref x0&, byref y0&)
   LOCAL x, y, xx, yy, nStyle, nCount AS long                                          
   appHelp_File = helpFile$                                                     
   if not isFile(helpFile$) then
      msgbox "No help available",%MB_ICONinformation, "Help File": exit sub
   end if
   dialog get loc h& to xx, yy 
   if ismissing(x0&) then x = 100 else x = x0&
   if ismissing(y0&) then y = 80 else y = y0&
   x = xx + x: y = yy + y
   nStyle = %WS_THICKFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX                                             
   if len(title$) = 0 then title$ = "Application Help"                  
   DIALOG NEW PIXELS, 0, title$, x, y, 640, 370, nStyle TO appHelp_hDlg
   nStyle = %TVS_EDITLABELS or %TVS_SHOWSELALWAYS OR %WS_TABSTOP                                            
   CONTROL ADD TREEVIEW, appHelp_hDlg, %IDC_appHelp_Treeview, "", 10, 5, 235, 325, nStyle
   control add label, appHelp_hDlg, %IDC_appHelp_Title, "", 250, 5, 355, 23
   control set color appHelp_hDlg, %IDC_appHelp_Title, %RGB_BLACK, %RGB_LIGHTGRAY
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, appHelp_hDlg, %IDC_appHelp_Textbox, "", 250, 30, 370, 300, nStyle
   control set color appHelp_hDlg, %IDC_appHelp_Textbox, %RGB_BLACK, %RGB_LEMONCHIFFON
   CONTROL ADD LINE, appHelp_hDlg, %IDC_appHelp_Splitbar, "", 245, 5, 5, 325, %SS_NOTIFY
   CONTROL ADD STATUSBAR, appHelp_hDlg, %IDC_appHelp_StatusBar, "", 0, 360, 700, 5
   DIALOG SHOW MODeless appHelp_hDlg, CALL appHelpProc
   DO
      DIALOG DOEVENTS
   LOOP WHILE ISWIN(h&)
eND sub

CALLBACK FUNCTION appHelpProc()
   LOCAL iRet, w, v, dx, i, k, m, n, hFile, nStyle, wp, found AS LONG                          
   LOCAL hInst, hIcon, hFont, hAccel, tabSpaces, tabUnits, nWordwrap, nPos AS long 
   local j as word
   local s, ss AS STRING                                                                        
   local t AS SIZEL
   LOCAL pNMHDR AS NMHDR PTR, pt AS POINTAPI, tvHitInfo AS TV_HITTESTINFO
   STATIC wi, ht, x, y, x1, x2, w1, w2, u, h, yy, hh, hdc, index, hPopupMenu AS LONG
   STATIC splitting, hItem, hTreeview, lastWordwrap, lastFound AS LONG
   static sItem, sFind as string
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         control handle CB.HNDL, %IDC_appHelp_Treeview to hTreeview
         control handle CB.HNDL, %IDC_appHelp_Textbox to hAppHelpTextbox
 
         'put GenHelp icon in explorer
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "GenHelp", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND cb.hndl, %WM_SETICON, 0, hIcon                                   

         'open and read the help file
         hFile = FREEFILE
         OPEN appHelp_File FOR BINARY AS hFile
         GET hFile,, appHelp_numTree
         if appHelp_numTree <= 0 then
            msgbox "No help content",%MB_ICONinformation, "Help File"
            close hFile: DIALOG END CB.HNDL: exit function
         end if
         'read in the help file        
         REDIM appHelp_Content(1 TO appHelp_numTree)
         REDIM appHelp_Titles(1 TO appHelp_numTree)
         redim appHelp_TreeLevel(1 to appHelp_numTree)
         redim appHelp_Indexes(1 to appHelp_numTree)
         redim appHelp_EditOpt(1 to appHelp_numTree)
         redim appHelp_TreeHandles(1 to appHelp_numTree) 
         FOR i = 1 TO appHelp_numTree
            GET hFile,, j: appHelp_Content(i) = SPACE$(j)
            GET hFile,, appHelp_Content(i)
         NEXT i
         FOR i = 1 TO appHelp_numTree
            GET hFile,, j: appHelp_Titles(i) = SPACE$(j)
            GET hFile,, appHelp_Titles(i)
         NEXT i
         get hFile,, appHelp_TreeLevel()
         get hFile,, appHelp_Indexes()
         get hFile,, appHelp_editOpt()
         CLOSE hFile
         appHelp_Treeview()
         lastWordwrap = appHelp_editOpt(1).nWordwrap

         'select first item
         treeview get root CB.HNDL, %IDC_appHelp_Treeview to hItem
         TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hItem              
         TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index
         TREEVIEW GET text CB.HNDL, %IDC_appHelp_Treeview, hItem TO s
         control set text cb.hndl, %IDC_appHelp_Title, space$(5) + s
         CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Content(index)
         
         'set styles and fonts                                      
         FONT NEW "MS Sans Serif", 12 TO hFont
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Title, hFont
         FONT NEW "MS Sans Serif", 10 TO hFont                                    
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Textbox, hFont          
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Treeview, hFont
         nStyle = %EC_LEFTMARGIN or %EC_RIGHTMARGIN
         CONTROL SEND cb.hndl, %IDC_appHelp_Textbox, %EM_SETMARGINS, nStyle, MAK(DWORD, 12, 12)
         
         'create popup menu for treeview control                      
         MENU NEW POPUP TO hAppHelpMenu0
         MENU ADD STRING, hAppHelpMenu0, "Find text" & $TAB & "CTRL+F", %IDM_appHelp_Find, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "Next" & $TAB & "F3", %IDM_appHelp_Next, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "Prev" & $TAB & "SHFT+F3", %IDM_appHelp_Prev, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "-", 0, 0
         MENU ADD STRING, hAppHelpMenu0, "Expand topic", %IDM_appHelp_ExpandTopic, %MF_enablED
         MENU ADD STRING, hAppHelpMenu0, "Collapse topic", %IDM_appHelp_CollapseTopic, %MF_enablED
         MENU ADD STRING, hAppHelpMenu0, "Expand all" & $TAB & "CTRL+X", %IDM_appHelp_ExpandAll, %MF_enablED
         MENU ADD STRING, hAppHelpMenu0, "Collapse all" & $TAB & "CTRL+C", %IDM_appHelp_CollapseAll, %MF_enabled
         MENU ADD STRING, hAppHelpMenu0, "-", 0, 0
         MENU ADD STRING, hAppHelpMenu0, "Print item" & $TAB & "CTRL+P", %IDM_appHelp_Print, %MF_ENABLED
         
         'create popup menu for textbox control
         MENU NEW POPUP TO hAppHelpMenu1
         MENU ADD STRING, hAppHelpMenu1, "Find text" & $TAB & "CTRL+F", %IDM_appHelp_Find, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu1, "Next" & $TAB & "F3", %IDM_appHelp_Next, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu1, "Prev" & $TAB & "SHFT+F3", %IDM_appHelp_Prev, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu1, "-", 0, 0
         MENU ADD STRING, hAppHelpMenu1, "Print item" & $TAB & "CTRL+P", %IDM_appHelp_Print, %MF_ENABLED
         
         'define accelerator keys                 
         REDIM ac(1 TO 7) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY OR %FCONTROL
         ac(1).key   = %VK_F
         ac(1).cmd   = %IDM_appHelp_Find
         ac(2).fvirt = %FVIRTKEY
         ac(2).key   = %VK_F3
         ac(2).cmd   =  %IDM_appHelp_Next
         ac(3).fvirt = %FVIRTKEY OR %FShift
         ac(3).key   = %VK_F3
         ac(3).cmd   =  %IDM_appHelp_Prev
         ac(4).fvirt = %FVIRTKEY OR %FCONTROL        
         ac(4).key   = %VK_P
         ac(4).cmd   = %IDM_appHelp_Print  
         ac(5).fvirt = %FVIRTKEY OR %FCONTROL        
         ac(5).key   = %VK_X
         ac(5).cmd   = %IDM_appHelp_ExpandAll
         ac(6).fvirt = %FVIRTKEY OR %FCONTROL        
         ac(6).key   = %VK_C
         ac(6).cmd   = %IDM_appHelp_CollapseAll
         ac(6).fvirt = %FVIRTKEY        
         ac(6).key   = %VK_F1
         ac(6).cmd   = %IDM_appHelp_F1
         ACCEL ATTACH CBHNDL, ac() TO hAccel

         STATUSBAR SET PARTS CB.HNDL, %IDC_appHelp_StatusBar, 9999: ss = space$(8)
         s = "  Right click mouse (or F1) for menu options"
         statusbar set text CB.HNDL, %IDC_appHelp_StatusBar, 1, 0, s 

         'need to subclass textbox to right click my own menu, not the Windows built-in menu
         origAppHelpTextboxProc = SetWindowLong(hAppHelpTextbox, %GWL_WNDPROC, CodePtr(subClassAppHelpTextbox))
      CASE %WM_SIZE
          'resize controls 
         DIALOG GET CLIENT CB.HNDL TO wi, ht
         wp = wi - x - 20                                                               
         control get client CB.HNDL, %IDC_appHelp_Textbox to wp, h
         CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview TO w, h                         
         CONTROL GET LOC CB.HNDL, %IDC_appHelp_SplitBar TO x, y                 
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, wi - x - 35, y + 18              
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, wi - x - 20, ht - 65         
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w, ht - 40
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_SplitBar, 5, ht - 40
      CASE %WM_SetCursor
         'show horizontal arrows if cursor is over splitter control
         iRet = GetDlgCtrlID (CB.WPARAM)
         IF iRet = %IDC_appHelp_SplitBar THEN MOUSEPTR 9: FUNCTION = 1
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemove, lbuttonup
         SELECT CASE HI(WORD, CB.LPARAM)
            CASE %WM_LBUTTONDOWN
               'sets flag to say splitter action has started (no actual movement yet)
               IF iRet = %IDC_appHelp_SplitBar THEN
                  Splitting = 1
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Treeview  TO x1, y
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview  TO w1, h
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Textbox  TO x2, yy
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Textbox  TO w2, hh                   
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_SplitBar  TO u, v: x = u
               END IF
            CASE %WM_MOUSEMOVE
               'resizes windows and moves splitter bar to match mouse position (if position has changed)
               IF splitting THEN
                  GetCursorPos pt               'pt has xy screen coordinates in pixels
                  ScreenToClient CB.HNDL, pt    'pt now has client coordinates in pixels
                  IF pt.x <> x THEN             'mouse position has changed... resize
                     dx = pt.x - x
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Treeview, x1, y                             
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w1 + dx, h

                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Title, x2 + dx, y
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, w2 - dx - 15, 23
                     
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Textbox, x2 + dx, y + 23
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, w2 - dx, h - 23
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_SplitBar, u + dx, y
                  END IF                                                                           
               END IF
            CASE %WM_LBUTTONUP
               'sets flag to say splitter action has ended
               Splitting = 0
         END SELECT     
     CASE %WM_NOTIFY 
         IF CB.NMID = %IDC_appHelp_Treeview THEN
            pNMHDR = CB.NMHDR                                                   
            IF @pNMHDR.code = %TVN_SELCHANGEDW THEN
               'directed here when treeview selection changes
               treeview set bold CB.HNDL, %IDC_appHelp_Treeview, hItem, 0
               TREEVIEW GET SELECT CB.HNDL, %IDC_appHelp_Treeview TO hItem
               TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index
               CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Content(index)                     
               TREEVIEW GET text CB.HNDL, %IDC_appHelp_Treeview, hItem TO s
               control set text cb.hndl, %IDC_appHelp_Title, space$(5) + s
               nWordWrap = appHelp_editOpt(index).nWordWrap 
               tabSpaces = appHelp_editOpt(index).TabSpaces
               if nWordwrap <> lastWordwrap then
                  nWordwrap = lastWordwrap: appHelp_wordwrapToggle(nWordwrap)
               end if
               lastWordwrap = nWordwrap 
               tabUnits = 4 * tabSpaces
               SendMessage hAppHelpTextbox, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)
            END IF
         END IF                                 
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            case %IDM_AppHelp_Find
               for i = 1 to appHelp_numTree                                      
                  if appHelp_treeHandles(i) = hItem then appHelp_nFind = i: exit for
               next i
               s = "Enter text:": ss = "": nPos = 0                  
               sFind = appHelp_Input(hAppHelpTextbox, s, "Text to Find", ss)
               sFind = lcase$(sFind)
               treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treehandles(appHelp_nFind)
               treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(appHelp_nFind), 1
               if len(sFind) = 0 then SetFocus hTreeview: exit function
               for i = appHelp_nFind to appHelp_numTree
                  treeview get user cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i) to k
                  s = lcase$(appHelp_Content(k)): found = instr(s, sFind)
                  if found > 0 then                                                  
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i)
                     treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
                     SendMessage hAppHelpTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1
                     SendMessage hAppHelpTextbox, %EM_ScrollCaret, 0, 0 
                     exit for
                  end if
               next i
               if found = 0 then msgbox "None found", , sFind
            case %IDM_AppHelp_Next                                                                  
               for i = 1 to appHelp_numTree 'get item number corresponding to hItem                                     
                  if appHelp_treeHandles(i) = hItem then appHelp_nFind = i: exit for
               next i
               SendMessage(hAppHelpTextbox, %EM_GetSel, varptr(m), varptr(n))
               nPos = n + 1
               for i = appHelp_nFind to appHelp_numTree
                  treeview get user cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i) to k
                  s = lcase$(appHelp_Content(k)): found = instr(nPos, s, sFind)
                  if found > 0 then
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i)
                     treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
                     SendMessage hAppHelpTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1
                     SendMessage hAppHelpTextbox, %EM_ScrollCaret, 0, 0
                     lastFound = found: appHelp_nFind = i
                     exit function
                  else 'not found, search next item 
                     nPos = 1
                  end if  
               next i
               if found = 0 then                                                     
                  msgbox "No more found", , sFind
                  SendMessage hAppHelpTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1 
               end if
            case %IDM_AppHelp_Prev 
               for i = 1 to appHelp_numTree                                      
                  if appHelp_treeHandles(i) = hItem then appHelp_nFind = i: exit for
               next i
               SendMessage(hAppHelpTextbox, %EM_GetSel, varptr(m), varptr(n))
               nPos = m + 1
               for i = appHelp_nFind to 1 step -1
                  treeview get user cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i) to k
                  s = lcase$(appHelp_Content(k)): if nPos then nPos = len(s) - nPos else nPos = 1
                  found = instr(-abs(nPos), s, sFind)
                  if found > 0 then
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i)
                     treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
                     SendMessage hApphelpTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1
                     SendMessage hAppHelpTextbox, %EM_ScrollCaret, 0, 0
                     lastFound = found: appHelp_nFind = i
                     nPos = found + 1: exit function
                  else 'not found, search previous item 
                     nPos = 0
                  end if  
               next i
               if found = 0 then                                                     
                  msgbox "No more found", , sFind
                  SendMessage hAppHelpTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
               end if
            case %IDM_appHelp_Print                                    
               'if cb.ctlmsg = %BN_CLICKED then
                  if len(appHelp_Content(index)) then appHelp_PrintItem
               'end if
            case %IDM_appHelp_ExpandTopic
               treeview set expanded cb.hndl, %IDC_appHelp_Treeview, hItem, 1 
            case %IDM_appHelp_CollapseTopic
               treeview set expanded cb.hndl, %IDC_appHelp_Treeview, hItem, 0               
            case %IDM_appHelp_ExpandAll
               for i = 1 to appHelp_numTree
                  treeview set expanded cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
               next i
            case %IDM_appHelp_CollapseAll   
               for i = 1 to appHelp_numTree
                  treeview set expanded cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 0
               next i
            case %IDM_appHelp_F1                   
               dialog get loc cb.hndl to x, y: x = x + 40: y = y + 50
               TrackPopupMenu hAppHelpMenu0, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, x, y, 0, CB.HNDL, BYVAL %NULL
         end select
      CASE %WM_CONTEXTMENU 'treeview popup menu                 
         IF CB.WPARAM = hTreeview THEN
            pt.x = LO(INTEGER, CB.LPARAM): pt.y = HI(INTEGER, CB.LPARAM)
            x = pt.x: y = pt.y
            ScreenToClient CB.WPARAM, pt
            tvHitInfo.pt = pt                                                              
            tvHitInfo.flags = %TVHT_ONITEMLABEL
            hItem = SendMessage(hTreeview, %TVM_HITTEST, 0, VARPTR(tvHitInfo))
            IF hItem = 0 THEN EXIT FUNCTION
            TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hItem
            TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index
            TrackPopupMenu hAppHelpMenu0, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, x, y, 0, CB.HNDL, BYVAL %NULL
         END IF
      CASE %WM_SYSCOMMAND                                            
         IF CB.CTL = %SC_CLOSE THEN
            dialog end cb.hndl
         end if                                                            
   end select  
end function

FUNCTION appHelp_Input(OPT BYVAL hParent AS LONG, BYVAL prompt AS STRING, _
                     BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string used to specify textbox size
   '      for 3 lines, use def = STRING$(60, 32) + $CRLF + $CRLF
   '-----------------------------------------------------------------------------
   LOCAL hInput, hdc, nStyle, hFont, numLines, ht, wi, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, sz AS asciiZ * 256, s, appHelp_InputStr AS STRING                                              
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, hParent, ti, , , 0, 0, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   numLines = parsecount(def, $crlf)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = MAX(t.cx, 130)
   sz = ti + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = MAX(t.cx, 150)
   wi = MAX(w1 + w2, w3, 150)
   ht = t.cy * numLines + 10
   IF hParent THEN                                                                                           
      DIALOG GET CLIENT hParent TO x, y
   ELSE
      DESKTOP GET CLIENT TO x, y
   END IF
   x = x/2 - wi/2: y = y/4
   DIALOG SET LOC hInput, x, y
   DIALOG SET SIZE hInput, wi + 40, ht + 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20
   nStyle = 0
   if numLines > 1 then nStyle = %ES_MULTILINE or %ES_WANTRETURN
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 10, 15, w2 + 5, ht, nStyle, %WS_EX_CLIENTEDGE
   IF LEN(def) THEN CONTROL SEND hInput, 9999, %EM_SETSEL, 0, -1
   s = "Search from top"                                        
   control add checkbox, hInput, 10000, s, 10, 45, 210, 15 
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", wi - 60, ht + 50, 80, 30
   DIALOG SET USER hInput, 1, VARPTR(appHelp_InputStr)
   DIALOG SHOW MODAL hInput, CALL appHelp_InputProc
   FUNCTION = TRIM$(appHelp_InputStr)                             
END FUNCTION

CALLBACK FUNCTION appHelp_InputProc()
   local nCheck as long
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
         control set check cb.hndl, 10000, -1
      CASE %WM_COMMAND
         IF CBCTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            if cb.ctl = %IDOK then
               control get check cb.hndl, 10000 to nCheck
               if nCheck then appHelp_nFind = 1
            end if 
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps 
            DIALOG END CB.HNDL                        
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

SUB appHelp_Treeview()
   'redraw treeview using savedIndexes(), treeLevel(), and helpTitles()
   LOCAL hTopic, hItem, hFirst, i, j, k AS LONG
   LOCAL s AS STRING
   TREEVIEW RESET appHelp_hDlg, %IDC_appHelp_Treeview 
   FOR i = 1 TO appHelp_numTree
      k = appHelp_Indexes(i)
      j = appHelp_treeLevel(k)
      s = appHelp_Titles(k)
      IF j THEN 'treeview item is a note
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic, %TVI_LAST, 0, 0, s TO hItem 
         TREEVIEW SET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem, k
      ELSE 'treeview item is a topic
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_appHelp_Treeview, 0, %TVI_LAST, 0, 0, s TO hTopic
         TREEVIEW SET USER appHelp_hDlg, %IDC_appHelp_Treeview, hTopic, k
         hItem = hTopic
      END IF
      appHelp_treeHandles(i) = hItem
   NEXT i                                                     
END SUB                                              

FUNCTION subClassAppHelpTextbox(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL x, y AS LONG                                                                                        
   local pt AS POINTAPI                                                                                  
   SELECT CASE wMsg&
      Case %WM_ContextMenu
         'this routine replaces the Windows built-in right click menu
         'WM_ContextMenu returns xy coordinates of mouse
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         TrackPopupMenuEx hAppHelpMenu1, 0, pt.x, pt.y, appHelp_hDlg, BYVAL 0
         Function = 0 : Exit Function                                       
   END SELECT
   ' Pass the message on to the original window procedure                            
   FUNCTION = CallWindowProc(origAppHelpTextboxProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB appHelp_wordWrapToggle(nWordwrap as long)                                                                  
   'just re-create textbox without %WS_HSCROLL and %ES_AUTOHSCROLL styles
   LOCAL x, y, wi, ht, nStyle, margins, hFont AS LONG
   LOCAL sText AS STRING
   control get text appHelp_hDlg, %IDC_appHelp_Textbox to sText
   control get loc appHelp_hDlg, %IDC_appHelp_Textbox to x, y
   CONTROL GET SIZE appHelp_hDlg, %IDC_appHelp_Textbox TO wi, ht
   CONTROL KILL appHelp_hDlg, %IDC_appHelp_Textbox
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN _
          OR %ES_NOHIDESEL or %WS_TABSTOP                            
   IF nWordWrap = 1 THEN
      nWordWrap = -1                                                
      nStyle = nStyle OR %WS_HSCROLL OR %ES_AUTOHSCROLL
   ELSE 'nWordWrap = -1
      nWordWrap = 1
   END IF 
   CONTROL ADD textbox, appHelp_hDlg, %IDC_appHelp_Textbox, "", x, y, wi, ht, nStyle
   CONTROL HANDLE appHelp_hDlg, %IDC_appHelp_Textbox TO hAppHelpTextbox
   control set color appHelp_hDlg, %IDC_appHelp_Textbox, %RGB_BLACK, %RGB_LEMONCHIFFON
   margins = %EC_LEFTMARGIN or %EC_RIGHTMARGIN                           
   SendMessage hAppHelpTextbox, %EM_SETMARGINS, margins, MAK(DWORD, 12, 12)
   FONT NEW "MS Sans Serif", 10 TO hFont
   CONTROL SET FONT appHelp_hDlg, %IDC_appHelp_Textbox, hFont                                
   control set text appHelp_hDlg, %IDC_appHelp_Textbox, sText
   origAppHelpTextboxProc = SetWindowLong(hAppHelpTextbox, %GWL_WNDPROC, CodePtr(subClassAppHelpTextbox))
END SUB
 
SUB appHelp_printItem()
   LOCAL m, n, k, i, j, mm, nLines, maxLines as long
   local tabCount, pgNo, multPgs, prn, hItem, index AS LONG
   LOCAL printerName, title, sTxt, s, sItem, temp, tabStr() AS STRING
   LOCAL leftMargin, topMargin, rightMargin, bottomMargin, pageWidth, pageHeight AS DOUBLE
   LOCAL x, wi, charHt, maxWidth AS DOUBLE
   LOCAL oTPrint AS iTPrint
   TREEVIEW GET select appHelp_hDlg, %IDC_appHelp_Treeview to hItem
   TREEVIEW GET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO index
   TREEVIEW GET TEXT appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO title
   LET oTPrint = CLASS "cTPrint"
   printerName = oTPrint.choosePrinter
   IF LEN(printerName) = 0 THEN EXIT SUB
   leftMargin = .75: topMargin = .25: rightMargin = .75: bottomMargin = .50
   oTPrint.setMargins(leftMargin, rightMargin, topMargin, bottomMargin)
   oTPrint.getPageSize(pageWidth, pageHeight)
   maxWidth = pageWidth - leftMargin - rightMargin
   oTPrint.newFont("Courier New", 10)
   sTxt = appHelp_Content(index)                                          
   maxLines = oTPrint.getLines: n = 1: nLines = 4
   IF oTPrint.duplexSet THEN
      GOSUB printPages: multPgs = ABS(multPgs) 'test for multiple pages
      oTPrint.duplexPrint(multPgs + 1)
   END IF
   prn = 1
   wi = oTPrint.getTextWidth("Page 1")
   oTPrint.beginDoc("appHelp")

   oTPrint.beginPage
   oTPrint.newFont("Courier New", 12, "u")
   oTPrint.printText(title, leftMargin, topMargin)
   oTPrint.newFont("Courier New", 10)
   oTPrint.printText("Page 1", pageWidth - rightMargin - wi, topMargin)
   oTPrint.getCharSize(x, charHt)
   oTPrint.setPos(leftMargin, 4 * charHt)

   n = 1: nLines = 4: pgNo = 1
   GOSUB printPages
   oTPrint.closePage
   oTPrint.closeDoc
   EXIT SUB

   printPages:
      DO
         k = INSTR(n, sTxt, CHR$(13, 10))
         IF k THEN
            temp = MID$(sTxt, n, k - n): INCR k
         ELSE
            temp = MID$(sTxt, n): k = LEN(sTxt)
         END IF

         tabCount = PARSECOUNT(temp, CHR$(9))
         IF tabCount > 1 THEN 'process tabs
            REDIM tabStr(1 TO tabCount)
            PARSE temp, tabStr(), CHR$(9)
            temp = ""
            FOR i = 1 TO tabCount - 1
               s = SPACE$(8)
               j = 8 - (LEN(tabStr(i)) MOD 8)
               IF j THEN s = SPACE$(j)
               temp = temp + tabStr(i) + s
            NEXT i
            temp = temp + tabStr(tabCount)
         END IF

         x = oTPrint.getTextWidth(temp)
         IF x <= maxWidth THEN 'print the line
            IF prn THEN oTPrint.printText(temp)
            INCR nLines
         ELSE 'else temp is too long... must break into lines
            DO
               s = oTPrint.truncate(temp, maxWidth)
               m = INSTR(-1, s, ANY " -,;:.()[]{}<>~/|\=")
               mm = INSTR(MID$(s, m, 1), ANY "([{<")
               IF prn THEN oTPrint.printText(TRIM$(LEFT$(temp, m - mm)))
               temp = MID$(temp, m - mm + 1): INCR nLines
               IF nLines > maxLines THEN GOSUB appHelp_nextPage
            LOOP WHILE m
         END IF
         IF nLines > maxLines THEN GOSUB appHelp_nextPage
         n = k + 1
      LOOP WHILE n < LEN(sTxt)
      RETURN

   appHelp_nextPage: 
      'print header for page
      IF multPgs <= 0 THEN multPgs = -1: RETURN
      oTPrint.closePage
      oTPrint.beginPage
      nLines = 4: INCR pgNo
      wi = oTPrint.getTextWidth("Page" + STR$(pgNo))
      oTPrint.newFont("Courier New", 12, "u")
      oTPrint.printText(title, leftMargin, topMargin)
      oTPrint.newFont("Courier New", 10)
      oTPrint.printText("Page" + STR$(pgNo), pageWidth - rightMargin - wi, topMargin)
      oTPrint.setPos(leftMargin, 4 * charHt)
      RETURN
END SUB
